;--------------------------------------
	LIST	P = 16F676, R = DEC
	include	p16f676.inc
;--------------------------------------
	include	TEMPO.INC
;--------------------------------------

	ORG	H'2100'
	DE	D'1'

	__CONFIG	H'3FC1'

#DEFINE	AUDIO	PORTA,0
#DEFINE	TLAC1	PORTA,1
#DEFINE	TLAC2	PORTA,3
#DEFINE	POTNC	PORTA,2

;--------------------------------------
; KONSTANTY
;--------------------------------------

OFFRAM	EQU	H'20'

TBEEPH_	EQU	D'0'
TBEEPL_	EQU	D'15'
TEMP0H_	EQU	D'7'
TEMP0L_	EQU	D'0'
DOBY_	EQU	D'4'

;--------------------------------------
; PAMETOVE BUNKY
;--------------------------------------

MEM_ST	EQU	OFFRAM
MEM_W	EQU	OFFRAM + D'1'
TMR2L	EQU	OFFRAM + D'2'
TMR2H	EQU	OFFRAM + D'3'
TAKT	EQU	OFFRAM + D'4'
TBEEPH	EQU	OFFRAM + D'5'
TBEEPL	EQU	OFFRAM + D'6'
REZON	EQU	OFFRAM + D'9'
REZONS	EQU	OFFRAM + D'10'
PERIOD	EQU	OFFRAM + D'11'
TAKTY	EQU	OFFRAM + D'12'
DOBA	EQU	OFFRAM + D'13'
DOBY	EQU	OFFRAM + D'14'
TMR3	EQU	OFFRAM + D'15'
TMR4	EQU	OFFRAM + D'16'
ADSTAT	EQU	OFFRAM + D'17'
BUFFCNT	EQU	OFFRAM + D'20'
TMR5H	EQU	OFFRAM + D'22'
TMR5L	EQU	OFFRAM + D'23'
TEMP1H	EQU	OFFRAM + D'24'
TEMP1L	EQU	OFFRAM + D'25'
MODE	EQU	OFFRAM + D'26'

ADRESL_	EQU	OFFRAM + D'27'
ADRESH_	EQU	OFFRAM + D'28'
ADRESL_A	EQU	OFFRAM + D'29'
ADRESH_A	EQU	OFFRAM + D'30'
ADRESL_B	EQU	OFFRAM + D'31'
ADRESH_B	EQU	OFFRAM + D'32'

PERIOD_	EQU	OFFRAM + D'33'
PERIOD2_	EQU	OFFRAM + D'34'
SIGNAL	EQU	OFFRAM + D'35'

SIGSETING	EQU	OFFRAM + D'36'

;--------------------------------------

	ORG	0x00
	GOTO	START
	
	ORG	0x04
INTPROC	MOVWF	MEM_W
	MOVF	STATUS,W
	MOVWF	MEM_ST
	BCF	STATUS,RP0

	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	BTFSS	INTCON,T0IF
	GOTO	INTEND
	BCF	INTCON,T0IF 
	INCF	TMR3,F
	INCF	TMR4,F

	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	INCF	TMR2L,F
	BTFSC	STATUS,Z
	INCF	TMR2H,F

	INCF	TMR5L,F
	BTFSC	STATUS,Z
	INCF	TMR5H,F

	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	MOVF	TBEEPL,W
	SUBWF	TMR2L,W
	MOVF	TBEEPH,W
	BTFSS	STATUS,C
	INCFSZ	TBEEPH,W
	SUBWF	TMR2H,W
	
	BTFSS	STATUS,C
	BSF	REZONS,0
	BTFSC	STATUS,C
	BCF	REZONS,0

	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	MOVF	TEMP1L,W
	SUBWF	TMR5L,W
	MOVF	TEMP1H,W
	BTFSS	STATUS,C
	INCFSZ	TEMP1H,W
	SUBWF	TMR5H,W

	BTFSC	STATUS,C
	CALL	BLIK

	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

INTEND	MOVF	MEM_ST,W
	MOVWF	STATUS
	SWAPF	MEM_W,F
	SWAPF	MEM_W,W
	RETFIE

TIK	CLRF	TMR2H
	CLRF	TMR2L
	MOVF	PERIOD_,W
	MOVWF	PERIOD	
	DECFSZ	DOBA,F
	RETURN
	MOVF	PERIOD2_,W
	MOVWF	PERIOD
	MOVF	DOBY,W
	CALL	DOBTAB
	MOVWF	DOBA
	RETURN

BLIK	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	CLRF	TMR5H
	CLRF	TMR5L
	INCF	TAKT,F

	MOVF	TAKT,W
	ANDLW	B'00000011'
	BTFSC	STATUS,Z
	CALL	TIK
	BTFSC	PIR1,TMR1IF
	CALL	BEEPS
	
	MOVF	MODE,W
	ANDLW	B'00000011'
	BTFSS	STATUS,Z
	GOTO	BLIKJ00
	MOVF	TAKT,W
	CALL	DIOTAB0
	MOVWF	PORTC
BLIKJ00	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	MOVF	MODE,W
	ANDLW	B'00000011'
	XORLW	D'1'
	BTFSS	STATUS,Z
	GOTO	BLIKJ01
	MOVF	TAKT,W
	CALL	DIOTAB1
	MOVWF	PORTC
BLIKJ01	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	MOVF	MODE,W
	ANDLW	B'00000011'
	XORLW	D'2'
	BTFSS	STATUS,Z
	GOTO	BLIKJ02
	MOVF	TAKT,W
	CALL	DIOTAB2
	MOVWF	PORTC
BLIKJ02	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	MOVF	MODE,W
	ANDLW	B'00000011'
	XORLW	D'3'
	BTFSS	STATUS,Z
	GOTO	BLIKJ03
	MOVF	TAKT,W
	CALL	DIOTAB3
	MOVWF	PORTC
BLIKJ03	BTFSC	PIR1,TMR1IF
	CALL	BEEPS

	RETURN

BEEPS	BCF	PIR1,TMR1IF
	MOVF	PERIOD,W
	SUBWF	TMR1L,F
	MOVLW	D'255'
	MOVWF	TMR1H
	BTFSC	REZONS,0
	GOTO	BEEPSJ00
	CLRF	REZON
	BCF	AUDIO
	RETURN
BEEPSJ00	INCF	REZON,F
	BTFSS	REZON,0
	BCF	AUDIO
	BTFSC	REZON,0
	BSF	AUDIO
	RETURN
	
START	MOVLW	B'00000111'
	MOVWF	CMCON
	MOVLW	B'00000000'
	MOVWF	PORTA
	MOVLW	B'00111110'
	MOVWF	PORTC
	BSF	STATUS,RP0
	MOVLW	B'11001000'
	MOVWF	OPTION_REG
	MOVLW	B'11111110'
	MOVWF	TRISA
	MOVLW	B'00000001'
	MOVWF	TRISC
	BCF	STATUS,RP0
	MOVLW	B'00100101'
	MOVWF	T1CON
	BSF	STATUS,RP0
	MOVLW	B'00000100'
	MOVWF	ANSEL
	MOVLW	B'00100000'
	MOVWF	ADCON1
	BCF	STATUS,RP0
	MOVLW	B'10001001'
	MOVWF	ADCON0
	MOVLW	D'2'
	MOVWF	PCLATH
	
	BSF	INTCON,T0IE
	BSF	STATUS,RP0
	BSF	PIE1,TMR1IE
	BCF	STATUS,RP0

	CALL	EELOAD
	MOVWF	SIGNAL
	CALL	SIGTAB1
	MOVWF	PERIOD_
	MOVF	SIGNAL,W
	CALL	SIGTAB2
	MOVWF	PERIOD2_

	MOVLW	TEMP0L_
	MOVWF	TEMP1L
	MOVLW	TEMP0H_
	MOVWF	TEMP1H
	MOVLW	TBEEPL_
	MOVWF	TBEEPL
	MOVLW	TBEEPH_
	MOVWF	TBEEPH
	MOVF	PERIOD_,W
	MOVWF	PERIOD
	MOVLW	D'1'
	MOVWF	DOBA
	MOVLW	DOBY_
	MOVWF	DOBY
	CLRF	ADRESL_
	CLRF	ADRESH_
	MOVLW	D'16' + D'1'
	MOVWF	BUFFCNT
	CLRF	MODE

	BCF	SIGSETING,0
	BTFSC	TLAC1
	GOTO	STARTJMP
	BTFSS	TLAC1
	GOTO	$ - 1
	CLRF	TMR1L
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	GOTO	$ - 1
	BSF	SIGSETING,0
	
STARTJMP	BTFSS	TLAC2
	GOTO	$ - 1
	BSF	INTCON,PEIE
	BSF	INTCON,GIE

LOOP	BTFSC	SIGSETING,0
	GOTO	SIGSET
	BTFSS	TLAC1
	GOTO	SET_MODE
LOOP_	BTFSC	TLAC2
	GOTO	LOOP05
	CLRF	TMR3
LOOP00	BTFSS	TMR3,7
	GOTO	LOOP00
LOOP01	BTFSS	TLAC2
	GOTO	LOOP01
	CLRF	TMR3
LOOP02	BTFSS	TMR3,7
	GOTO	LOOP02
	DECF	DOBY,F
	MOVLW	DOBY_
	BTFSC	STATUS,Z
	MOVWF	DOBY
	MOVLW	D'1'
	MOVWF	DOBA
LOOP05	CALL	ADRUN
	GOTO	LOOP
SET_MODE	CLRF	TMR3
LOOP06	BTFSS	TMR3,7
	GOTO	LOOP06
LOOP07	BTFSS	TLAC2
	CALL	A4
	BTFSS	TLAC1
	GOTO	LOOP07
	CLRF	TMR3
LOOP08	BTFSS	TMR3,7
	GOTO	LOOP08
	INCF	MODE,F
	GOTO	LOOP_
	
SIGSET	BTFSC	TLAC1
	GOTO	LOOP_
	CLRF	TMR3
	BTFSS	TMR3,7
	GOTO	$ - 1
	BTFSS	TLAC1
	GOTO	$ - 1
	CLRF	TMR3
	BTFSS	TMR3,7
	GOTO	$ - 1
	INCF	SIGNAL,W
	ANDLW	B'00000111'
	MOVWF	SIGNAL
	CALL	EESAVE
	MOVF	SIGNAL,W
	CALL	SIGTAB1
	MOVWF	PERIOD_
	MOVF	SIGNAL,W
	CALL	SIGTAB2
	MOVWF	PERIOD2_
	GOTO	LOOP_

ADRUN	BTFSS	ADSTAT,0
	GOTO	AQUISIT
	BTFSC	ADCON0,GO
	RETURN
	DECF	BUFFCNT,F
	BTFSC	STATUS,Z
	CALL	NEXTBUFF

	BSF	STATUS,RP0
	MOVF	ADRESL,W
	BCF	STATUS,RP0
	ADDWF	ADRESL_,F
	BTFSC	STATUS,C
	INCF	ADRESH_,F
	MOVF	ADRESH,W
	ADDWF	ADRESH_,F

	CLRF	TMR4
	BCF	ADSTAT,0
	RETURN
AQUISIT	BTFSS	TMR4,4
	RETURN
	BSF	ADCON0,GO
	BSF	ADSTAT,0
	RETURN
NEXTBUFF	MOVF	ADRESL_,W
	MOVWF	ADRESL_A
	MOVF	ADRESH_,W
	MOVWF	ADRESH_A

	MOVF	ADRESL_B,W
	SUBWF	ADRESL_A,F
	MOVF	ADRESH_B,W
	BTFSS	STATUS,C
	INCFSZ	ADRESH_B,W
	SUBWF	ADRESH_A,F
	BTFSC	STATUS,C
	GOTO	SKOK_00
	MOVF	ADRESH_A,W
	XORLW	255
	MOVWF	ADRESH_A
	MOVF	ADRESL_A,W
	XORLW	255
	MOVWF	ADRESL_A
	INCF	ADRESL_A,F
	BTFSC	STATUS,Z
	INCF	ADRESH_A,F
SKOK_00	MOVF	ADRESH_A,F
	BTFSS	STATUS,Z
	GOTO	SKOK_01
	MOVF	ADRESL_A,W
	ANDLW	B'11100000'
	BTFSC	STATUS,Z
	GOTO	SKOK_02
SKOK_01	MOVF	ADRESL_,W
	MOVWF	ADRESL_B
	MOVF	ADRESH_,W
	MOVWF	ADRESH_B
SKOK_02	MOVF	ADRESH_B,W
	ANDLW	B'00111111'
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	CALL	TABH
	MOVWF	TEMP1H
	MOVF	ADRESH_B,W
	ANDLW	B'00111111'
	CALL	TABL
	MOVWF	TEMP1L
	BSF	INTCON,GIE
NEXTBUFF0	CLRF	ADRESL_
	CLRF	ADRESH_
	MOVLW	D'16'
	MOVWF	BUFFCNT
	RETURN
	

	ORG	D'512'

TABH	ANDLW	B'00111111'
	ADDWF	PCL,F
	RETLW	TIME00/256
	RETLW	TIME01/256
	RETLW	TIME02/256
	RETLW	TIME03/256
	RETLW	TIME04/256
	RETLW	TIME05/256
	RETLW	TIME06/256
	RETLW	TIME07/256
	RETLW	TIME08/256
	RETLW	TIME09/256
	RETLW	TIME10/256
	RETLW	TIME11/256
	RETLW	TIME12/256
	RETLW	TIME13/256
	RETLW	TIME14/256
	RETLW	TIME15/256
	RETLW	TIME16/256
	RETLW	TIME17/256
	RETLW	TIME18/256
	RETLW	TIME19/256
	RETLW	TIME20/256
	RETLW	TIME21/256
	RETLW	TIME22/256
	RETLW	TIME23/256
	RETLW	TIME24/256
	RETLW	TIME25/256
	RETLW	TIME26/256
	RETLW	TIME27/256
	RETLW	TIME28/256
	RETLW	TIME29/256
	RETLW	TIME30/256
	RETLW	TIME31/256
	RETLW	TIME32/256
	RETLW	TIME33/256
	RETLW	TIME34/256
	RETLW	TIME35/256
	RETLW	TIME36/256
	RETLW	TIME37/256
	RETLW	TIME38/256
	RETLW	TIME39/256
	RETLW	TIME40/256
	RETLW	TIME41/256
	RETLW	TIME42/256
	RETLW	TIME43/256
	RETLW	TIME44/256
	RETLW	TIME45/256
	RETLW	TIME46/256
	RETLW	TIME47/256
	RETLW	TIME48/256
	RETLW	TIME49/256
	RETLW	TIME50/256
	RETLW	TIME51/256
	RETLW	TIME52/256
	RETLW	TIME53/256
	RETLW	TIME54/256
	RETLW	TIME55/256
	RETLW	TIME56/256
	RETLW	TIME57/256
	RETLW	TIME58/256
	RETLW	TIME59/256
	RETLW	TIME60/256
	RETLW	TIME61/256
	RETLW	TIME62/256
	RETLW	TIME63/256

TABL	ANDLW	B'00111111'
	ADDWF	PCL,F
	RETLW	TIME00%256
	RETLW	TIME01%256
	RETLW	TIME02%256
	RETLW	TIME03%256
	RETLW	TIME04%256
	RETLW	TIME05%256
	RETLW	TIME06%256
	RETLW	TIME07%256
	RETLW	TIME08%256
	RETLW	TIME09%256
	RETLW	TIME10%256
	RETLW	TIME11%256
	RETLW	TIME12%256
	RETLW	TIME13%256
	RETLW	TIME14%256
	RETLW	TIME15%256
	RETLW	TIME16%256
	RETLW	TIME17%256
	RETLW	TIME18%256
	RETLW	TIME19%256
	RETLW	TIME20%256
	RETLW	TIME21%256
	RETLW	TIME22%256
	RETLW	TIME23%256
	RETLW	TIME24%256
	RETLW	TIME25%256
	RETLW	TIME26%256
	RETLW	TIME27%256
	RETLW	TIME28%256
	RETLW	TIME29%256
	RETLW	TIME30%256
	RETLW	TIME31%256
	RETLW	TIME32%256
	RETLW	TIME33%256
	RETLW	TIME34%256
	RETLW	TIME35%256
	RETLW	TIME36%256
	RETLW	TIME37%256
	RETLW	TIME38%256
	RETLW	TIME39%256
	RETLW	TIME40%256
	RETLW	TIME41%256
	RETLW	TIME42%256
	RETLW	TIME43%256
	RETLW	TIME44%256
	RETLW	TIME45%256
	RETLW	TIME46%256
	RETLW	TIME47%256
	RETLW	TIME48%256
	RETLW	TIME49%256
	RETLW	TIME50%256
	RETLW	TIME51%256
	RETLW	TIME52%256
	RETLW	TIME53%256
	RETLW	TIME54%256
	RETLW	TIME55%256
	RETLW	TIME56%256
	RETLW	TIME57%256
	RETLW	TIME58%256
	RETLW	TIME59%256
	RETLW	TIME60%256
	RETLW	TIME61%256
	RETLW	TIME62%256
	RETLW	TIME63%256

;----------------------------------------
; animace LED diod
;----------------------------------------

DIOTAB0	MOVF	TAKT,W		;jedna dioda
	ANDLW	B'00000111'
	ADDWF	PCL,F
	RETLW	B'11101111'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11101111'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11111111'

DIOTAB1	MOVF	TAKT,W		;dve diody stridave kratce
	ANDLW	B'00000111'
	ADDWF	PCL,F
	RETLW	B'11111101'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11111011'
	RETLW	B'11111111'
	RETLW	B'11111111'
	RETLW	B'11111111'

DIOTAB2	MOVF	TAKT,W		;dve diody stridave dlouze
	ANDLW	B'00000111'
	ADDWF	PCL,F
	RETLW	B'11111101'
	RETLW	B'11111101'
	RETLW	B'11111101'
	RETLW	B'11111101'
	RETLW	B'11111011'
	RETLW	B'11111011'
	RETLW	B'11111011'
	RETLW	B'11111011'

DIOTAB3	MOVF	TAKT,W		;rezim "kyvadlo"
	ANDLW	B'00000111'
	ADDWF	PCL,F
	RETLW	B'11111101'
	RETLW	B'11011111'
	RETLW	B'11101111'
	RETLW	B'11110111'
	RETLW	B'11111011'
	RETLW	B'11110111'
	RETLW	B'11101111'
	RETLW	B'11011111'

;---------------------------------------------
; takty
;---------------------------------------------

DOBTAB	ANDLW	B'00000111'	;pouzite takty
	ADDWF	PCL,F
	RETLW	D'1'
	RETLW	D'6'
	RETLW	D'4'
	RETLW	D'3'
	RETLW	D'2'

;---------------------------------------------
; vyska klapani
;---------------------------------------------

SIGTAB1	ANDLW	B'00000111'	;vyska obycejneho klapnuti (udano jako delka frek. periody)
	ADDWF	PCL,F
	RETLW	D'240'
	RETLW	D'180'
	RETLW	D'140'
	RETLW	D'120'
	RETLW	D'100'
	RETLW	D'85'
	RETLW	D'70'
	RETLW	D'60'

SIGTAB2	ANDLW	B'00000111'	;vyska prizvukoveho klapnuri (udano jako delka frek. periody)
	ADDWF	PCL,F
	RETLW	D'190'
	RETLW	D'140'
	RETLW	D'100'
	RETLW	D'90'
	RETLW	D'70'
	RETLW	D'57'
	RETLW	D'42'
	RETLW	D'32'

;---------------------------------------------

A4	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	BTFSS	TLAC2
	GOTO	$ - 1
	MOVLW	B'00000101'
	MOVWF	T1CON
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	GOTO	$ - 1
A4_JMP	MOVLW	D'112'
	SUBWF	TMR1L,F
	MOVLW	D'255' - D'4'
	MOVWF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	GOTO	$ - 1
	BSF	AUDIO
	MOVLW	D'113'
	SUBWF	TMR1L,F
	MOVLW	D'255' - D'4'
	MOVWF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	GOTO	$ - 1
	BCF	AUDIO
	BTFSC	TLAC2
	GOTO	A4_JMP
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	BTFSS	TLAC2
	GOTO	$ - 1
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSS	PIR1,TMR1IF
	MOVLW	B'00100101'
	MOVWF	T1CON
	BSF	INTCON,GIE
	DECF	MODE,F
	RETURN

EESAVE	BSF	STATUS,RP0
	MOVWF	EEDATA
	CLRF	EEADR
	BSF	EECON1,WREN
	BCF	INTCON,GIE
	BTFSC	INTCON,GIE
	GOTO	$ - 2
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	BSF	INTCON,GIE
	BTFSC	EECON1,WR
	GOTO	$ - 1
	BCF	STATUS,RP0
	RETURN

EELOAD	BSF	STATUS,RP0
	CLRF	EEADR
	BSF	EECON1,RD
	MOVF	EEDATA,W
	BCF	STATUS,RP0
	RETURN

	END
